function buildPrompt(movies) {
  var promptData = {
      searchResults: movies,
      test:movies,
      yesAction  : 'addMovie',
      yesResponse: 'Ok, i\'ve added ' + movies[0].original_title + ' (' + movies[0].year + ')' + ' to your list of movies to download.'
  };

  if (movies.length > 1) {
    promptData.noAction = 'suggestNextMovie';
    promptData.noResponse = 'Ok, did you mean ' + movies[1].original_title + ' (' + movies[1].year + ')' + '?';
  }
  else {
    promptData.noAction = 'endSession';
    promptData.noResponse = 'Ok. I\'m out of suggestions. Sorry about that.';
  }

  return promptData;
}

function sendSearchResponse(movies, movieName,  resp) {
  if(!movies || !movies.length) {
    return resp.say('I\'m afraid I can\'t find any movies for ' + movieName).send();
    }
  
    resp
    .say(['Add', movies[0].original_title, '(' + movies[0].year + ')', 'to your list?'].join(' '))
    .session('promptData', buildPrompt(movies))
    .shouldEndSession(false)
    .send();
  }

function findValues(obj, key){
	var values =  findValuesHelper(obj, key, []);
  return values[0].toString();
}

function findValuesHelper(obj, key, list) {
  if (!obj) return list;
  if (obj instanceof Array) {
    for (var i in obj) {
        list = list.concat(findValuesHelper(obj[i], key, []));
    }
    return list;
  }
  if (obj[key]) list.push(obj[key]);

  if ((typeof obj == "object") && (obj !== null) ){
	  var children = Object.keys(obj);
	  if (children.length > 0){
	  	for (i = 0; i < children.length; i++ ){
	        list = list.concat(findValuesHelper(obj[children[i]], key, []));
	  	}
	  }
  }
  return list;
}

function isInLibrary(movies){
  
  var inLibrary = false;
  
  if (findValues(movies, 'status') == 'done')
  {
    inLibrary = true;
  }   
   return inLibrary;
}

function formatSearchResults(movies)
{
  try{
    
    if (movies != undefined)
    {
    
    var newMovies = [];
  
  for (var i = 0; i < movies.length; i++) 
  { newMovies.push({ 
    original_title: movies[i].original_title, 
    inLibrary: movies[i].in_library,
    year: movies[i].year,
    titles: movies[i].titles,
    imdb: movies[i].imdb }); 
  } 
  
    }
  
  return newMovies;

}
catch (e)
{  
  console.log(e);
}
}

module.exports = {
  buildPrompt: buildPrompt,
  sendSearchResponse: sendSearchResponse,
  formatSearchResults: formatSearchResults
};

